<?php
#-----------------------------------------------------------------------
#  display source of script if requested so
#-----------------------------------------------------------------------
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) {
   //--self downloader --
   $filenameReal = __FILE__;
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header('Connection: close');
   readfile($filenameReal);
   exit;
}   
#
#-----------------------------------------------------------------------
$pageName	= 'wsFireDanger.php';
$pageVersion	= '4.00 2017-06-14';
# RELEASE HISTORY ------------------------------------------------------
# 4.00 2017-06-14 Release 4.0 version
# 4.01 2024-02-20 Test version without ttf 
#-----------------------------------------------------------------------
# Based on calculation-script from  SLOweather.com
# excample https://www.weather-above.com/meteotemplate/plugins/fireDanger/fireDanger.php
# If another contributor is not mentioned please contact me wvdkuil (at) gmail.com
#-----------------------------------------------------------------------
# 
# Parameters:  temperature  => converted if needed 
#              relative Humidity  
# Calculation: Chandler Burning index 
# Output:      Graphic .png with settings and correct colors /words
# Image used   5 graphics for each of the 5 danger levels
#              default located in the same directory as the script
#              optional a TTF font-file, located in the same folder as the images
#-----------------------------------------------------------------------
# SETTINGS:
#
$fw_folder      = './';                 // same folder as the script is executed from
#$fw_folder      = './firedanger/';      // script is included from another folder
$ws_font_file   = $fw_folder.'PFDinDisplayPro-Bold.ttf';
#
#-----------------------------------------------------------------------
#    
# Check parameters either by php variables or wsFireDanger.php?fwuom=c,&fwtemp=12.3&fwhum=45.6
#
if (!isset ($fw_uom) ) 
     {   $fw_uom = 'c'; } # echo print_r($_REQUEST); exit;
    
if (isset($_REQUEST['fwuom']) && $_REQUEST['fwuom'] <> '') 
     {  $fw_uom = strtolower ($_REQUEST['fwuom']);
        if ($fw_uom <> 'f') { $fw_uom = 'c'; } }

if (isset($_REQUEST['fwtemp'])) 
     {  $fwtemp = (float) $_REQUEST['fwtemp']; }

if (isset($_REQUEST['fwhum'])) 
     {  $fwhum  = (float) $_REQUEST['fwhum'];}

if (isset($_REQUEST['lang'])) 
     {  $string = trim((string) $_REQUEST['lang']);
        $lang   = substr ($string.'  ',0,2);}

if (!isset ($fwtemp)  || !isset ($fwhum) ) 
     {   echo '<h3> Missing variable for calculating CBI </h3>'; return;}

ws_fw_trans_setup ();

if ($fw_uom == 'f')     // normalize from f to c
     {  $cTemp   = 5*($fwtemp - 32) / 9;}
else {  $cTemp   = 1.0 * $fwtemp;}

$fwtemp = round ($fwtemp, 1);
$fwhum  = round ($fwhum,  0);
#------- calculate Chandler Index --------------------------------------
#CBI = (((110 - 1.373*RH)       - 0.54 * (10.20 - T))     * (124 * 10**(-0.0142*RH)))/60
#
$cbi = (((110 - 1.373 * $fwhum) - 0.54 * (10.20 - $cTemp)) * (124 * pow(10,(-0.0142*$fwhum))))/60;

#------- find correct image for the Chandler Index
if ($cbi >  97.5 )    { $cbitxt = 'EXTREME';    $cbiimg = 'extreme.png'; }
elseif ($cbi >= 90 )  { $cbitxt = 'VERY HIGH';  $cbiimg = 'vhigh.png'; } 
elseif ($cbi >= 75 )  { $cbitxt = 'HIGH';       $cbiimg = 'high.png';} 
elseif ($cbi >= 50 )  { $cbitxt = 'MODERATE';   $cbiimg = 'moderate.png';} 
else                  { $cbitxt = 'LOW';        $cbiimg = 'low.png';}
$cbi    = round($cbi,0); // to diplay on image we do not need a floatingpoint value

$fwimg          = imagecreatefrompng($fw_folder.$cbiimg); 
imageAlphaBlending($fwimg, true);
imageSaveAlpha($fwimg, true);

$degree_units   = strtoupper($fw_uom);   
$color_red      = imagecolorallocate($fwimg,255,0,0);
$color_green    = imagecolorallocate($fwimg,0,128,0);  
$color_white    = imagecolorallocate($fwimg,255,255,255);
$color_black    = imagecolorallocate($fwimg,1,1,1);

$string         = (int)$fwtemp.$degree_units.'  '.(int)$fwhum.'%';
ws_center_text($fwimg, 3,  132/2, 118,$string,$color_green);
$string = 'CBI: '.$cbi;
if ($cbitxt == 'HIGH') {$cbi_color = $color_black; } else {$cbi_color = $color_white; }
ws_center_text($fwimg, 4,  132/2, 130,$string,$color_red);
ws_center_text($fwimg, 4,  132/2, 97,$fw_lang[$cbitxt],$cbi_color);
ws_center_text($fwimg, 5,  132/2, 15,$fw_lang['FIRE DANGER'],$color_white);

# ---------------------------------
header("Content-type: image/png"); 
imagepng($fwimg,NULL);
imagedestroy($fwimg);

# ---based on function imagecenteredtext() ---------------------
# Original author UNKNOWN, please mail me correct author name if you know him / her
# adapted to more look like built-in imagestring function
# bool imagestring ( resource $image , int $font , int $x , int $y , string $string , int $color )
#
# Text centering function for image creation  centers on provided x, y coordinates
# You must pass all parameters even if you aren't using them.
# $x       = x coordinate where the text will be centered
# $y       = y coordinate where the text will be centered
# $text    = the text to be written
# $size    = font size for built-in GD fonts (1,2,3,4, or 5)
# $ttfsize = font size for ttf fonts. Use just like you would in a word processor
# $color   = color as defined in the allocate colors section below
# $angle   = for ttf fonts, determines the angle for the text.
#
function ws_center_text($im, $size, $x, $y, $text, $color, $ttfsize= 10 , $angle= 0) {
        global $ws_font_file, $anti_alias ;
        $gdinf = gd_info();
        $x      -= (int)(imagefontwidth($size) * strlen($text)) / 2;
        $y      -= (int)(imagefontheight($size)) / 2;
        imagestring($im, (int)$size, (int)$x, (int)$y - 3, $text, $color);
} // eof ws_center_text
#
function ws_fw_trans_setup () {
        global $lang, $fw_lang;
        if (!isset ($lang) ) {$lang = 'nl';}
        if ($lang == 'en') {
                $fw_lang['EXTREME']     =   'EXTREME';
                $fw_lang['VERY HIGH']   =   'VERY HIGH';
                $fw_lang['HIGH']        =   'HIGH';
                $fw_lang['MODERATE']    =   'MODERATE';
                $fw_lang['LOW']         =   'LOW'; 
                $fw_lang['FIRE DANGER'] =   'FIRE DANGER'; }
#        
        else {  $fw_lang['EXTREME']     =   'EXTREEM';
                $fw_lang['VERY HIGH']   =   'ZEER HOOG';
                $fw_lang['HIGH']        =   'HOOG';
                $fw_lang['MODERATE']    =   'MATIG';
                $fw_lang['LOW']         =   'LAAG';
                $fw_lang['FIRE DANGER'] =   'BRAND GEVAAR'; }
} // eof ws_fw_trans_setup
